% Performance Bounds and Suboptimal Policies for Multi-Period Investment
% by Stephen Boyd, Mark T. Mueller, Brendan O'Donoghue, Yang Wang
% ----------------------------------------------------------------

% first solve the SDP to get approximate value functions
solve_sdp;

% make CVXGEN solver
make_solver;

% run Monte Carlo simulations to determine policy performance
run_montecarlo;

% perform robustness analysis
run_perturbations;

% plot sample trajectories
gen_plots;

